      subroutine calcres ( mat, sol, rhs, res, nxa, nya, matsol,
     +                    sl1, sl2, sl3, sl4)
c ======================================================================
c
c        programmer     Jos van Kan
c
c       version 1.1    10-04-1997
c         utilizes module mgpreset instead of common block cmgconst
c       version 1.0    27-03-1997
c
c
c   copyright (c) 1997
c   all rights reserved. no part of this publication may be reproduced,
c   stored in a retrieval system ( e.g., in memory, disk, or core)
c   or be transmitted by any means, electronic, mechanical, photocopy,
c   recording, or otherwise, without written permission from the
c   author.
c
c
c **********************************************************************
c
c                       DESCRIPTION
c
c   calculates b - Ax on actual level
c
c **********************************************************************
c
c                       KEYWORDS
c
c   multi_grid
c **********************************************************************
c
c         MODULES USED
c
      use mgpreset
c
c **********************************************************************
c
c                       INPUT / OUTPUT PARAMETERS
c
      implicit none
      integer sl1, sl2, sl3, sl4
      integer nxa, nya
      double precision
     + mat (1-sl1:nxa+sl2, 1-sl3:nya+sl4, 9),
     + sol (1-sl1:nxa+sl2, 1-sl3:nya+sl4),
     + rhs (1-sl1:nxa+sl2, 1-sl3:nya+sl4),
     + res (1-sl1:nxa+sl2, 1-sl3:nya+sl4),
     + matsol (1-sl1:nxa+sl2, 1-sl3:nya+sl4)

c     mat       i    The nx x ny x 9 coefficient matrix of the
c                    discrete Laplacian
c     matsol    o    vector with mat * sol
c     nxa       i    Number of grid x points on this level
c     nya       i    Number of grid y points on this level
c     res       i    Residual (any level)
c     rhs       i    Right hand side  (any level)
c     sl1       i    Slack variable, x lower bound
c     sl2       i    Slack variable, x upper bound
c     sl3       i    Slack variable, y lower bound
c     sl4       i    Slack variable, y upper bound
c     sol       i    Solution vector (any level)
c **********************************************************************
c
c                       COMMON BLOCKS
c
c **********************************************************************
c
c                       LOCAL PARAMETERS
c
c **********************************************************************
c
c                       SUBROUTINES CALLED
c
c     MULTMATV  Matrix vector multiplication (any level) (MG)
c     TRIADVEC  Adds x + b y with x and y vectors, b scalar (MG)
c **********************************************************************
c
c                       I/O
c
c **********************************************************************
c
c                       ERROR MESSAGES
c
c **********************************************************************
c
c                       PSEUDO CODE
c   trivial
c
c **********************************************************************
c
c                       DATA STATEMENTS
c
c ======================================================================
c
      call multmatv ( mat, sol, matsol, nxa, nya, sl1, sl2, sl3, sl4)
      call triadvec ( rhs, -1d0, matsol, res, nxa, nya,
     +                sl1, sl2, sl3, sl4)
      end
