      subroutine getscrs ( ibuf, size )
c ======================================================================
c
c        programmer     Jos van Kan
c
c       version 1.1    10-04-1997
c         utilizes module mgpreset instead of common block cmgconst
c       version 1.0    27-03-1997
c
c
c   copyright (c) 1996
c   all rights reserved. no part of this publication may be reproduced,
c   stored in a retrieval system ( e.g., in memory, disk, or core)
c   or be transmitted by any means, electronic, mechanical, photocopy,
c   recording, or otherwise, without written permission from the
c   author.
c
c
c **********************************************************************
c
c                       DESCRIPTION
c
c   Gets a block of size reals and lower the scratch space offset
c   accordingly.
c   There is very primitive memory management only.
c **********************************************************************
c
c                       KEYWORDS
c
c   multi_grid
c **********************************************************************
c
c         MODULES USED
c
      use mgpreset
c
c **********************************************************************
c
c                       INPUT / OUTPUT PARAMETERS
c
      implicit none
      integer ibuf(*), size

c     ibuf      i    Integer array of dimension 300 that contains the
c                    administration of this particular multi grid block.
c     size      i    Size of the block
c **********************************************************************
c
c                       COMMON BLOCKS
c
c **********************************************************************
c
c                       LOCAL PARAMETERS
c
c **********************************************************************
c
c                       SUBROUTINES CALLED
c
c     ERRMSG    Reports and counts errors (MG)
c **********************************************************************
c
c                       I/O
c
c **********************************************************************
c
c                       ERROR MESSAGES
c
c **********************************************************************
c
c                       PSEUDO CODE
c
c **********************************************************************
c
c                       DATA STATEMENTS
c
c ======================================================================
c
      ibuf (wirecnti) = ibuf (wirecnti) + 1
      ibuf (offscri) = ibuf (offscri) - size
      if (ibuf (offrbufi).gt.ibuf (offscri)) then
      call errmsg ('getscrspace', 'max buffersize exceeded', .TRUE.,
     +             ibuf)
      end if
      end
